SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF OBJECT_ID(N'dbo.usp_CalcRatios') IS NOT NULL
    DROP PROCEDURE dbo.usp_CalcRatios;
GO
-- =============================================
-- Author:		Aaron N. Cutshall
-- Create date: 29-Jul-2017
-- Description:	Calculate aggregate ratios of customers by store
-- =============================================
CREATE PROCEDURE [dbo].[usp_CalcRatios]
AS
BEGIN
	SET NOCOUNT ON;

	IF OBJECT_ID('dbo.tbl_MeasureRatio', 'U') IS NOT NULL DROP TABLE dbo.tbl_MeasureRatio;
	CREATE TABLE dbo.tbl_MeasureRatio (
		MeasureId INT NOT NULL,
		StoreId INT NOT NULL,
		Ratio FLOAT NOT NULL
		);

	INSERT INTO dbo.tbl_MeasureRatio(MeasureId, StoreId, Ratio)
	SELECT mr.MeasureId, c.StoreId, SUM(CAST(mr.NumRuleResult AS FLOAT))/SUM(CAST(mr.DenRuleResult AS FLOAT))
	FROM dbo.tbl_MeasureResults mr
	INNER JOIN dbo.tbl_Customer c
		ON c.CustomerId = mr.CustomerId
	GROUP BY mr.MeasureId, c.StoreId

-- Show table contents for demo purposes only
	select * from dbo.tbl_MeasureRatio;
END
